unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,shellapi;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Timer1: TTimer;
    Edit2: TEdit;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
Tcolor_rus = record
   Name:string;
   Rus_name:string;
   Color:Tcolor;
end;

var
  Form1: TForm1;
  ColorArray :array of Tcolor_rus;
  ColorArrayCount:integer;
  hDC:Thandle;
implementation

{$R *.dfm}
uses math;
Procedure AddCode2(name,Rus_name:string;color:Tcolor);
begin
  ColorArrayCount:=ColorArrayCount+1;
  setlength(ColorArray,ColorArrayCount);
  ColorArray[ColorArrayCount-1].Color:=color;
  ColorArray[ColorArrayCount-1].Name:=name;
  ColorArray[ColorArrayCount-1].Rus_name:=Rus_name;
end;

Function GetColorList_rus:string;
var x:Integer;
begin
result:='';
  for X:=0 to ColorArrayCount-1 do begin
  if ColorArray[x].Rus_name<>'' then
        result:=result+ColorArray[x].Rus_name+#13+#10;
  end;
end;
Function GetElemntFromRus(text:string):Tcolor;
var x:integer;
begin
 for X:=0 to ColorArrayCount-1 do
   if ColorArray[x].Rus_name=text then begin
      result:=ColorArray[x].Color;
      exit;
   end;
end;
Procedure InitColor; //   
begin
    AddCode2('Alice Blue',' ',RGB($F0,$F8,$FF));
    AddCode2('Alizarin Crimson',' ',RGB($E3,$26,$36));
    AddCode2('Almond',' ',RGB($EF,$DE,$CD));
    AddCode2('Amaranth','',RGB($E5,$2B,$50));
    AddCode2('Amber','',RGB($FF,$BF,$00));
    AddCode2('American Rose',' ',RGB($FF,$03,$3E));
    AddCode2('Amethyst','',RGB($99,$66,$CC));
    AddCode2('Anti-flash White',' ',RGB($F2,$F3,$F4));
    AddCode2('Apple Green',' ',RGB($8D,$B6,$00));
    AddCode2('Aqua','  ',RGB($00,$FF,$FF));
    AddCode2('Aquamarine','',RGB($7F,$FF,$D4));
    AddCode2('Army Green',' ',RGB($4B,$53,$20));
    AddCode2('Arsenic','',RGB($3B,$44,$4B));
    AddCode2('Asparagus','',RGB($7B,$A0,$5B));
    AddCode2('Azure',', ',RGB($00,$7F,$FF));
    AddCode2('Battleship Grey','',RGB($84,$84,$82));
    AddCode2('Beige',', ',RGB($F5,$F5,$DC));
    AddCode2('Bistre','',RGB($3D,$2B,$1F));
    AddCode2('Bittersweet','',RGB($FE,$6F,$5E));
    AddCode2('Black','׸',RGB($00,$00,$00));
    AddCode2('Blond','',RGB($FA,$F0,$BE));
    AddCode2('Blue','',RGB($00,$00,$FF));
    AddCode2('Bondi Blue','  ',RGB($00,$95,$B6));
    AddCode2('Boston University Red','',RGB($CC,$00,$00));
    AddCode2('Brass','',RGB($B5,$A6,$42));
    AddCode2('Bright green','-',RGB($66,$FF,$00));
    AddCode2('Bright turquoise','-',RGB($08,$E8,$DE));
    AddCode2('Bright violet','-',RGB($CD,$00,$CD));
    AddCode2('Bronze','',RGB($CD,$7F,$32));
    AddCode2('Brown','',RGB($96,$4B,$00));
    AddCode2('Buff',' , ',RGB($F0,$DC,$82));
    AddCode2('Burgundy','',RGB($90,$00,$20));
    AddCode2('Burnt Orange',' ',RGB($CC,$55,$00));
    AddCode2('Burnt Sienna',' ',RGB($E9,$74,$51));
    AddCode2('Burnt umber',',  ',RGB($8A,$33,$24));
    AddCode2('Camouflage green','',RGB($78,$86,$6B));
    AddCode2('Cardinal','Ҹ-, ',RGB($C4,$1E,$3A));
    AddCode2('Carmine','-',RGB($96,$00,$18));
    AddCode2('Carrot','',RGB($ED,$91,$21));
    AddCode2('Celadon','',RGB($AC,$E1,$AF));
    AddCode2('Cerise',' ',RGB($DE,$31,$63));
    AddCode2('Cerulean','',RGB($00,$7B,$A7));
    AddCode2('Cerulean blue','-',RGB($2A,$52,$BE));
    AddCode2('Chartreuse',' , ',RGB($7F,$FF,$00));
    AddCode2('Chestnut','',RGB($CD,$5C,$5C));
    AddCode2('Chocolate','',RGB($D2,$69,$1E));
    AddCode2('Cinnamon','',RGB($7B,$3F,$00));
    AddCode2('Cobalt',' ',RGB($00,$47,$AB));
    AddCode2('Copper','',RGB($B8,$73,$33));
    AddCode2('Coral',', -',RGB($FF,$7F,$50));
    AddCode2('Corn','',RGB($FB,$EC,$5D));
    AddCode2('Cornflower blue','',RGB($64,$95,$ED));
    AddCode2('Cream','',RGB($FF,$FD,$D0));
    AddCode2('Crimson','Ҹ-, , ',RGB($DC,$14,$3C));
    AddCode2('Cyan',', ',RGB($00,$FF,$FF));
    AddCode2('Dark brown','Ҹ-',RGB($65,$43,$21));
    AddCode2('Dark cerulean','Ҹ-',RGB($08,$45,$7E));
    AddCode2('Dark chestnut','Ҹ-',RGB($98,$69,$60));
    AddCode2('Dark coral','Ҹ-',RGB($CD,$5B,$45));
    AddCode2('Dark goldenrod','Ҹ-',RGB($B8,$86,$0B));
    AddCode2('Dark green','Ҹ-',RGB($01,$32,$20));
    AddCode2('Dark Indigo','Ҹ , ',RGB($31,$00,$62));
    AddCode2('Dark Khaki','Ҹ , ',RGB($BD,$B7,$6B));
    AddCode2('Dark Olive','Ҹ-',RGB($55,$68,$32));
    AddCode2('Dark pastel green','Ҹ -',RGB($03,$C0,$3C));
    AddCode2('Dark Peach','Ҹ-',RGB($FF,$DA,$B9));
    AddCode2('Dark pink','Ҹ-',RGB($E7,$54,$80));
    AddCode2('Dark salmon','Ҹ ',RGB($E9,$96,$7A));
    AddCode2('Dark Scarlet','Ҹ-',RGB($56,$03,$19));
    AddCode2('Dark slate gray','Ҹ- , -',RGB($2F,$4F,$4F));
    AddCode2('Dark spring green','Ҹ -',RGB($17,$72,$45));
    AddCode2('Dark tan','Ҹ -',RGB($91,$81,$51));
    AddCode2('Dark tangerine','Ҹ-',RGB($FF,$A8,$12));
    AddCode2('Dark Tea Green','Ҹ  ',RGB($BA,$DB,$AD));
    AddCode2('Dark turquoise','Ҹ-',RGB($11,$60,$62));
    AddCode2('Dark violet','  ',RGB($42,$31,$89));
    AddCode2('Deep sky blue',' ',RGB($00,$BF,$FF));
    AddCode2('Denim',' ',RGB($15,$60,$BD));
    AddCode2('Dodger blue','-',RGB($1E,$90,$FF));
    AddCode2('Eggplant','',RGB($99,$00,$66));
    AddCode2('Emerald','',RGB($50,$C8,$78));
    AddCode2('Fern green',' ',RGB($4F,$79,$42));
    AddCode2('Flax','',RGB($EE,$DC,$82));
    AddCode2('Fuchsia','',RGB($FF,$00,$FF));
    AddCode2('Gamboge','',RGB($E4,$9B,$0F));
    AddCode2('Gold','',RGB($FF,$D7,$00));
    AddCode2('Goldenrod','-',RGB($DA,$A5,$20));
    AddCode2('Gradus Blue',' ',RGB($00,$7D,$FF));
    AddCode2('Gray','',RGB($80,$80,$80));
    AddCode2('Gray-asparagus',' ',RGB($46,$59,$45));
    AddCode2('Gray-Tea Green','  ',RGB($CA,$DA,$BA));
    AddCode2('Green','',RGB($00,$FF,$00));
    AddCode2('Green-yellow','Ƹ-',RGB($AD,$FF,$2F));
    AddCode2('Heliotrope','',RGB($DF,$73,$FF));
    AddCode2('Hot pink','- ',RGB($FC,$0F,$C0));
    AddCode2('Indian Red',' , ',RGB($CD,$5C,$5C));
    AddCode2('Indigo','',RGB($4B,$00,$82));
    AddCode2('International orange (Safety orange)',' () ',RGB($FF,$4F,$00));
    AddCode2('Jade','',RGB($00,$A8,$6B));
    AddCode2('Khaki','',RGB($C3,$B0,$91));
    AddCode2('Klein Blue',' ',RGB($3A,$75,$C4));
    AddCode2('Lavender',', -',RGB($E6,$E6,$FA));
    AddCode2('Lavender Blush','-',RGB($FF,$F0,$F5));
    AddCode2('Lawn Green',' ',RGB($7C,$FC,$00));
    AddCode2('Lemon','',RGB($FD,$E9,$10));
    AddCode2('Lemon Cream','-',RGB($FF,$FA,$CD));
    AddCode2('Light brown','-',RGB($CD,$85,$3F));
    AddCode2('Lilac','',RGB($C8,$A2,$C8));
    AddCode2('Lime','',RGB($CC,$FF,$00));
    AddCode2('Linen','',RGB($FA,$F0,$E6));
    AddCode2('Magenta',', ',RGB($FF,$00,$FF));
    AddCode2('Malachite','  ()',RGB($0B,$DA,$51));
    AddCode2('Maroon','-',RGB($80,$00,$00));
    AddCode2('Mauve','-',RGB($99,$33,$66));
    AddCode2('Midnight Blue','-',RGB($00,$33,$66));
    AddCode2('Mint Green','  ()',RGB($98,$FF,$98));
    AddCode2('Moss green',' ',RGB($AD,$DF,$AD));
    AddCode2('Mountbatten pink',' ',RGB($99,$7A,$8D));
    AddCode2('Mustard','',RGB($FF,$DB,$58));
    AddCode2('Navajo white',' ',RGB($FF,$DE,$AD));
    AddCode2('Navy','Ҹ-,    ',RGB($00,$00,$80));
    AddCode2('Ochre','',RGB($CC,$77,$22));
    AddCode2('Old Gold',' ',RGB($CF,$B5,$3B));
    AddCode2('Old Lace',' ',RGB($FD,$F5,$E6));
    AddCode2('Olive','',RGB($80,$80,$00));
    AddCode2('Olive Drab','-',RGB($6B,$8E,$23));
    AddCode2('Orange','',RGB($FF,$A5,$00));
    AddCode2('Orchid','',RGB($DA,$70,$D6));
    AddCode2('Pale Blue','-',RGB($AF,$EE,$EE));
    AddCode2('Pale brown','-',RGB($98,$76,$54));
    AddCode2('Pale carmine','-, . ',RGB($AF,$40,$35));
    AddCode2('Pale chestnut','-',RGB($DD,$AD,$AF));
    AddCode2('Pale cornflower blue','-',RGB($AB,$CD,$EF));
    AddCode2('Pale magenta','-',RGB($F9,$84,$E5));
    AddCode2('Pale mauve',' -',RGB($99,$66,$66));
    AddCode2('Pale pink','-',RGB($FA,$DA,$DD));
    AddCode2('Pale red-violet','',RGB($DB,$70,$93));
    AddCode2('Pale Sandy Brown','- ',RGB($DA,$BD,$AB));
    AddCode2('Pale yellow','',RGB($F0,$DC,$82));
    AddCode2('Pang','',RGB($C7,$FC,$EC));
    AddCode2('Papaya whip',' ',RGB($FF,$EF,$D5));
    AddCode2('Pastel green','-',RGB($77,$DD,$77));
    AddCode2('Pastel pink','-',RGB($FF,$D1,$DC));
    AddCode2('Peach','',RGB($FF,$E5,$B4));
    AddCode2('Peach-orange','-',RGB($FF,$CC,$99));
    AddCode2('Peach-yellow','Ƹ-',RGB($FA,$DF,$AD));
    AddCode2('Pear','',RGB($D1,$E2,$31));
    AddCode2('Periwinkle','',RGB($CC,$CC,$FF));
    AddCode2('Persian blue',' ',RGB($66,$00,$FF));
    AddCode2('Pine Green',' ',RGB($01,$79,$6F));
    AddCode2('Pink','',RGB($FF,$C0,$CB));
    AddCode2('Pink-orange','-',RGB($FF,$99,$66));
    AddCode2('Plum','',RGB($66,$00,$66));
    AddCode2('Powder blue',' ',RGB($00,$33,$99));
    AddCode2('Prussian blue',' ',RGB($00,$31,$53));
    AddCode2('Puce','-,  (.), -, ',RGB($CC,$88,$99));
    AddCode2('Pumpkin','',RGB($FF,$75,$18));
    AddCode2('Purple','',RGB($66,$00,$99));
    AddCode2('Raw umber','',RGB($73,$4A,$12));
    AddCode2('Red','',RGB($FF,$00,$00));
    AddCode2('Red-violet','-',RGB($C7,$15,$85));
    AddCode2('Robin egg blue','  ',RGB($00,$CC,$CC));
    AddCode2('Rosy Brown','-',RGB($BC,$8F,$8F));
    AddCode2('Royal Blue','- ( )',RGB($41,$69,$E1));
    AddCode2('Russet','-',RGB($75,$5A,$57));
    AddCode2('Rust','-',RGB($B7,$41,$0E));
    AddCode2('Safety Orange (Blaze Orange)',' ',RGB($FF,$99,$00));
    AddCode2('Saffron','',RGB($F4,$C4,$30));
    AddCode2('Salmon','',RGB($FF,$8C,$69));
    AddCode2('Sandy brown',' ',RGB($F4,$A4,$60));
    AddCode2('Sangria','',RGB($92,$00,$0A));
    AddCode2('Sapphire','',RGB($08,$25,$67));
    AddCode2('Scarlet','-, ',RGB($FF,$24,$00));
    AddCode2('School bus yellow','   ',RGB($FF,$D8,$00));
    AddCode2('Sea Green',' ',RGB($2E,$8B,$57));
    AddCode2('Seashell','  ',RGB($FF,$F5,$EE));
    AddCode2('Selective yellow',' ',RGB($FF,$BA,$00));
    AddCode2('Sepia','',RGB($70,$42,$14));
    AddCode2('Silver','',RGB($C0,$C0,$C0));
    AddCode2('Slate gray',' ',RGB($70,$80,$90));
    AddCode2('Spring Green',' ',RGB($00,$FF,$7F));
    AddCode2('Steel blue',' ',RGB($46,$82,$B4));
    AddCode2('Swamp green','',RGB($AC,$B7,$8E));
    AddCode2('Tan',' ',RGB($D2,$B4,$8C));
    AddCode2('Tangerine','',RGB($FF,$CC,$00));
    AddCode2('Tea Green',' ',RGB($D0,$F0,$C0));
    AddCode2('Teal','-',RGB($00,$80,$80));
    AddCode2('Tenn?','-',RGB($CD,$57,$00));
    AddCode2('Thistle','',RGB($D8,$BF,$D8));
    AddCode2('Titian','',RGB($d5,$3e,$07));
    AddCode2('Tomato','',RGB($FF,$63,$47));
    AddCode2('Turquoise',', . ',RGB($30,$D5,$C8));
    AddCode2('Ultramarine','',RGB($12,$0A,$8F));
    AddCode2('United Nations Blue','  ',RGB($5B,$92,$E5));
    AddCode2('Vanilla','',RGB($F3,$E5,$AB));
    AddCode2('Vermilion',', .  ()',RGB($E3,$42,$34));
    AddCode2('Violet','',RGB($8B,$00,$FF));
    AddCode2('Violet-eggplant','-',RGB($99,$11,$99));
    AddCode2('Viridian','-',RGB($40,$82,$6D));
    AddCode2('Wheat','',RGB($F5,$DE,$B3));
    AddCode2('White','',RGB($FF,$FF,$FF));
    AddCode2('Wine','',RGB($72,$2F,$37));
    AddCode2('Wisteria','',RGB($C9,$A0,$DC));
    AddCode2('Xanadu','',RGB($73,$86,$78));
    AddCode2('Yandex',' ',RGB($ff,$cc,$00));
    AddCode2('Yellow','Ƹ',RGB($FF,$FF,$00));
    AddCode2('Zaffre','-',RGB($00,$14,$A8));
    AddCode2('Zinnwaldite','',RGB($EB,$C2,$AF));

end;
procedure TForm1.FormCreate(Sender: TObject);
var hWnd1:HWND;
begin
hWnd1 := GetDesktopWindow;
hDC := GetDC(0);
InitColor;
form1.ListBox1.Items.Text:=GetColorList_rus;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var C,M,Y,K:integer;
begin
 if form1.ListBox1.ItemIndex>-1 then begin
    form1.Panel1.Color:=GetElemntFromRus(form1.ListBox1.Items[form1.ListBox1.ItemIndex]);
    c:=GetCValue(form1.Panel1.color);
    M:=GetMValue(form1.Panel1.color);
    Y:=GetYValue(form1.Panel1.color);
    K:=GetKValue(form1.Panel1.color);
    form1.Label1.Caption:=
    'RGB('+inttostr(getRvalue(form1.Panel1.Color))+','+inttostr(getGvalue(form1.Panel1.Color))+','+inttostr(getBvalue(form1.Panel1.Color))+')'+#13+#10;
    form1.Label1.Caption:=form1.Label1.Caption+'CMYK('+inttostr(c)+','+inttostr(m)+','+inttostr(y)+','+inttostr(k)+')';
    edit1.Text:=Label1.Caption;

    form1.Edit2.text:=form1.ListBox1.Items[form1.ListBox1.ItemIndex];

//    CMYK

 end;
end;

Function GetColorFromMassiv(Color_Value:Tcolor;Var DeltaV:integer):integer;
var x:integer;
    mindeX:integer;
    r1,g1,b1:integer;
    ri,gi,bi:integer;
    deltamin,delta:real;
begin
//Color_Value:=clblack;
r1:=GetRValue(color_value);
g1:=GetGValue(color_value);
b1:=GetBValue(color_value);
delta:=255*255*255;
deltamin:=delta;
mindeX:=ColorArrayCount-2;

 for X:=0 to ColorArrayCount-1 do begin
    ri:=GetRValue(ColorArray[x].Color);
    gi:=GetGValue(ColorArray[x].Color);
    bi:=GetBValue(ColorArray[x].Color);
    delta:=power((Ri-R1),2) + power((Gi-G1),2) + power((Bi-B1),2);
  if delta<deltamin then begin deltamin:=delta;
            mindeX:=x;
         end;

        end;
DeltaV:=abs(ColorArray[mindeX].Color-Color_Value);
result:=mindeX;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
if form1.Timer1.Enabled then
form1.Timer1.Enabled:=false
else form1.Timer1.Enabled:=true;
if form1.Timer1.Enabled then form1.Button1.Caption:=''
else form1.Button1.Caption:='';                          
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var mp:Tpoint;
    COLORREF:Dword;
    s:string;
    x:Integer;
    vm:integer;
begin
  windows.GetCursorPos(mp);
  form1.StatusBar1.Panels[0].Text:='x='+inttostr(mp.x)+' y= '+inttostr(mp.y);
  COLORREF:=windows.GetPixel(hDC,mp.x,mp.y);
  form1.Panel1.color:=COLORREF;
  s:=ColorArray[GetColorFromMassiv(form1.Panel1.Color,vm)].Rus_name;
  for X:=0 to form1.ListBox1.Items.Count-1 do begin
    if s=form1.ListBox1.Items[x] then begin
       form1.ListBox1.ItemIndex:=x;
       ListBox1Click(Sender);
       form1.StatusBar1.Panels[1].Text:=' '+inttostr(Round(vm/(255*255*255)*100))+'%';
       exit;
    end;
  end;




end;

procedure TForm1.Label2Click(Sender: TObject);
begin
shellapi.ShellExecute(application.Handle,'open','http://netsoftware.ucoz.ru/','','',5);

end;

end.
